const DEFAULT_BUF_SIZE = 64

# TODO: Add here the missing related to those three
const SSL_FILETYPE_PEM = 1
const SSL_OP_NO_SSLv3 = 0x02000000
const EVP_MAX_MD_SIZE = 64

const BIO_FLAGS_READ         = 0x01
const BIO_FLAGS_WRITE        = 0x02
const BIO_FLAGS_IO_SPECIAL   = 0x03
const BIO_FLAGS_RWS          = (BIO_FLAGS_READ|BIO_FLAGS_WRITE|BIO_FLAGS_IO_SPECIAL)
const BIO_FLAGS_SHOULD_RETRY = 0x08
const BIO_FLAGS_MEM_RDONLY   = 0x200
const BIO_FLAGS_NONCLEAR_RST = 0x400
const BIO_FLAGS_IN_EOF       = 0x800

@enum SSL_ERRORS begin
    SSL_ERROR = 1
    SSL_WANT_READ = 2
    SSL_WANT_WRITE = 3
    SSL_SYSCALL = 5
    SSL_ZERO_RETURN = 6
end

@enum SSL_VERIFY begin
    VERIFY_NONE = 0x00
    VERIFY_PEER = 0x01
    VERIFY_FAIL_IF_NO_PEER_CERT = 0x02
    VERIFY_CLIENT_ONCE = 0x04
    VERIFY_POST_HANDSHAKE = 0x08
end

@enum SSL_VERSION begin
    SSL3_VERSION = 0x0300
    TLS1_VERSION
    TLS1_1_VERSION
    TLS1_2_VERSION
    TLS1_3_VERSION
end
