# https://www.openssl.org/docs/man1.1.0/man3/TLS_server_method.html
TLSv1_2_method() = ccall((:TLSv1_2_method, libssl), Ptr{SSL_Method}, ())
TLSv1_2_server_method() = ccall((:TLSv1_2_server_method, libssl), Ptr{SSL_Method}, ())
TLSv1_2_client_method() = ccall((:TLSv1_2_client_method, libssl), Ptr{SSL_Method}, ())
# Not defined in my openssl release
# SSLv3_method() = ccall((:SSLv3_method, libssl), Ptr{SSL_Method}, ())
# SSLv3_server_method() = ccall((:SSLv3_server_method, libssl), Ptr{SSL_Method}, ())
# SSLv3_client_method() = ccall((:SSLv3_client_method, libssl), Ptr{SSL_Method}, ())
TLSv1_method() = ccall((:TLSv1_method, libssl), Ptr{SSL_Method}, ())
TLSv1_server_method() = ccall((:TLSv1_server_method, libssl), Ptr{SSL_Method}, ())
TLSv1_client_method() = ccall((:TLSv1_client_method, libssl), Ptr{SSL_Method}, ())
TLSv1_1_method() = ccall((:TLSv1_1_method, libssl), Ptr{SSL_Method}, ())
TLSv1_1_server_method() = ccall((:TLSv1_1_server_method, libssl), Ptr{SSL_Method}, ())
TLSv1_1_client_method() = ccall((:TLSv1_1_client_method, libssl), Ptr{SSL_Method}, ())
TLS_method() = ccall((:TLS_method, libssl), Ptr{SSL_Method}, ())
TLS_server_method() = ccall((:TLS_server_method, libssl), Ptr{SSL_Method}, ())
TLS_client_method() = ccall((:TLS_client_method, libssl), Ptr{SSL_Method}, ())
SSLv23_method() = ccall((:SSLv23_method, libssl), Ptr{SSL_Method}, ())
SSLv23_server_method() = ccall((:SSLv23_server_method, libssl), Ptr{SSL_Method}, ())
SSLv23_client_method() = ccall((:SSLv23_client_method, libssl), Ptr{SSL_Method}, ())
DTLS_method() = ccall((:DTLS_method, libssl), Ptr{SSL_Method}, ())
DTLS_server_method() = ccall((:DTLS_server_method, libssl), Ptr{SSL_Method}, ())
DTLS_client_method() = ccall((:DTLS_client_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_method() = ccall((:DTLSv1_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_server_method() = ccall((:DTLSv1_server_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_client_method() = ccall((:DTLSv1_client_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_2_method() = ccall((:DTLSv1_2_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_2_server_method() = ccall((:DTLSv1_2_server_method, libssl), Ptr{SSL_Method}, ())
DTLSv1_2_client_method() = ccall((:DTLSv1_2_client_method, libssl), Ptr{SSL_Method}, ())
